/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.alibaba.druid.util.StringUtils
 *  com.ruoyi.system.utils.dbsync.compare.CompareUnits
 *  com.ruoyi.system.utils.dbsync.meta.Column
 *  com.ruoyi.system.utils.dbsync.meta.Index
 *  com.ruoyi.system.utils.dbsync.meta.MetaData
 *  com.ruoyi.system.utils.dbsync.meta.Table
 *  com.ruoyi.system.utils.dbsync.util.SqlUtil
 */
package com.ruoyi.system.utils.dbsync.compare;

import com.alibaba.druid.util.StringUtils;
import com.ruoyi.system.utils.dbsync.meta.Column;
import com.ruoyi.system.utils.dbsync.meta.Index;
import com.ruoyi.system.utils.dbsync.meta.MetaData;
import com.ruoyi.system.utils.dbsync.meta.Table;
import com.ruoyi.system.utils.dbsync.util.SqlUtil;
import java.util.ArrayList;
import java.util.List;

public class CompareUnits {
    private MetaData source;
    private MetaData target;
    private List<String> changeSql;

    public CompareUnits(MetaData source, MetaData target) {
        this.source = source;
        this.target = target;
        this.changeSql = new ArrayList();
    }

    public void compare() {
        this.compareTables();
        this.compareKeys();
    }

    private void compareSchema() {
    }

    private void compareTables() {
        for (Table table : this.source.getTables().values()) {
            if (this.target.getTables().get(table.getTableName()) == null) {
                this.changeSql.add(table.getCreateTable() + ";");
                continue;
            }
            this.compareSingelTable(table, (Table)this.target.getTables().get(table.getTableName()));
        }
    }

    private void compareSingelTable(Table sourceTable, Table targetTable) {
        this.compareColumns(sourceTable, targetTable);
    }

    private void compareColumns(Table sourceTable, Table targetTable) {
        String sql;
        String after = null;
        for (Column column : sourceTable.getColumns().values()) {
            if (targetTable.getColumns().get(column.getName()) == null) {
                sql = "alter table `" + this.target.getSchema() + "`." + targetTable.getTableName() + " add " + column.getName() + " ";
                sql = sql + column.getType() + " ";
                sql = column.getIsNull().equals("NO") ? sql + "NOT NULL " : sql + "NULL ";
                if (column.getDefaultValue() != null) {
                    sql = sql + "DEFAULT " + (column.getDefaultValue2() == null ? "NULL" : SqlUtil.getDbString((String)column.getDefaultValue())) + " ";
                }
                if (column.getComment() != null) {
                    sql = sql + "COMMENT " + SqlUtil.getDbString((String)column.getComment()) + " ";
                }
                if (after != null) {
                    sql = sql + "after " + after;
                }
                this.changeSql.add(sql + ";");
            } else {
                sql = "alter table `" + this.target.getSchema() + "`." + targetTable.getTableName() + " change " + column.getName() + " ";
                Column sourceColumn = column;
                Column targetColumn = (Column)targetTable.getColumns().get(sourceColumn.getName());
                String sqlExtend = this.compareSingleColumn(sourceColumn, targetColumn);
                if (sqlExtend != null) {
                    this.changeSql.add(sql + sqlExtend + ";");
                }
            }
            after = column.getName();
        }
        for (Column column : targetTable.getColumns().values()) {
            if (sourceTable.getColumns().get(column.getName()) != null) continue;
            sql = "alter table `" + this.target.getSchema() + "`." + targetTable.getTableName() + " drop " + column.getName() + " ";
            this.changeSql.add(sql + ";");
        }
    }

    private String compareSingleColumn(Column sourceColumn, Column targetColumn) {
        ArrayList modify = new ArrayList();
        if (sourceColumn.equals((Object)targetColumn)) {
            return null;
        }
        String changeSql = "";
        if (!sourceColumn.getName().equals(targetColumn.getName())) {
            throw new RuntimeException("the bug in this tool");
        }
        changeSql = changeSql + sourceColumn.getName() + " ";
        changeSql = changeSql + sourceColumn.getType() + " ";
        changeSql = sourceColumn.getIsNull().equals("NO") ? changeSql + "NOT NULL " : changeSql + "NULL ";
        if (sourceColumn.getExtra().toUpperCase().indexOf("AUTO_INCREMENT") != -1) {
            changeSql = changeSql + "AUTO_INCREMENT ";
        }
        if (!StringUtils.isEmpty((CharSequence)sourceColumn.getDefaultValue())) {
            changeSql = changeSql + "DEFAULT " + sourceColumn.getDefaultValue() + " ";
        }
        if (sourceColumn.getComment() != null) {
            changeSql = changeSql + "COMMENT " + SqlUtil.getDbString((String)sourceColumn.getComment()) + " ";
        }
        return changeSql;
    }

    private void compareKeys() {
        for (Table table : this.source.getTables().values()) {
            if (this.target.getTables().get(table.getTableName()) == null) continue;
            this.compareSingleKeys(table, (Table)this.target.getTables().get(table.getTableName()));
        }
    }

    private void compareSingleKeys(Table sourceTable, Table targetTable) {
        String sql;
        for (Index index : sourceTable.getIndexes().values()) {
            sql = "alter table `" + this.target.getSchema() + "`." + targetTable.getTableName() + " ";
            if (targetTable.getIndexes().get(index.getIndexName()) != null) continue;
            sql = index.getIndexName().equals("PRIMARY") ? sql + "add primary key " : (index.getNotUnique().equals("0") ? sql + "add unique " + index.getIndexName() + " " : sql + "add index " + index.getIndexName() + " ");
            sql = sql + "(`";
            for (String key : index.getColumns()) {
                sql = sql + key.trim() + "`,`";
            }
            sql = sql.substring(0, sql.length() - 2) + ")";
            this.changeSql.add(sql + ";");
        }
        for (Index index : targetTable.getIndexes().values()) {
            if (sourceTable.getIndexes().get(index.getIndexName()) != null) continue;
            sql = "alter table `" + this.target.getSchema() + "`." + targetTable.getTableName() + " ";
            sql = index.getIndexName().equals("PRIMARY") ? sql + "drop primary key " : sql + "drop index " + index.getIndexName();
            this.changeSql.add(sql + ";");
        }
    }

    public MetaData getSource() {
        return this.source;
    }

    public void setSource(MetaData source) {
        this.source = source;
    }

    public MetaData getTarget() {
        return this.target;
    }

    public void setTarget(MetaData target) {
        this.target = target;
    }

    public List<String> getChangeSql() {
        return this.changeSql;
    }

    public void setChangeSql(List<String> changeSql) {
        this.changeSql = changeSql;
    }
}

